package com.example.demo.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.web.bind.annotation.*;

@RestController
public class DemoController {

    @Autowired
    private StringRedisTemplate stringRedisTemplate;

    @RequestMapping(value = "/demo", method = RequestMethod.POST, consumes = "application/json")
    @ResponseBody
    public JSONObject demo(@RequestBody JSONObject jsonObject) {
        JSONObject result = jsonObject.getJSONObject("request");
        String type = result.get("type").toString();
        String input;  //请求文本
        String redisKey = "input_count";
        String res = "{'version': '1.0','response': {'speak': {'type': 'text','text': '%s','ssml': 'SSML markup text string to speak'}},'shouldEndSession': %b}"; //忽略了部分DSK协议字段,shouldEndSession字段决定是否结束本轮对话
        JSONObject response = jsonObject.parseObject(String.format(res, "error", true));  // 响应报文
        JSONArray slots;
        try {
            if (type.equals("start")) {  //唤醒
                res = String.format(res, "已唤醒", false);
                response = jsonObject.parseObject(res);
            } else {  //继续对话
                slots = result.getJSONArray("inputs");
                input = slots.getJSONObject(0).get("input").toString();
                if (input.equals("helloworld") || input.equals("你好世界") || input.equals("世界你好")) { //根据关键词返回内容
                    stringRedisTemplate.opsForValue().increment(redisKey, 1);
                    Integer count = Integer.parseInt(stringRedisTemplate.opsForValue().get(redisKey));
                    res = String.format(res, String.format("这是第%d次helloworld", count), false);
                } else if (input.equals("再见") || type.equals("end")) { //结束对话,退出说法可以根据产品自行设定
                    res = String.format(res, "结束对话", true);
                    stringRedisTemplate.delete(redisKey);
                } else {
                    res = String.format(res, "我听不懂你在说什么", false);
                }
                response = jsonObject.parseObject(res);
            }
        } catch (Exception e) {
            System.out.println("Exception thrown  :" + e);
        } finally {
            return response;
        }
    }
}
